#include "Player_Movement.h"
#include "sgg/graphics.h"
#include <iostream>
// Ρυθμίσεις παραθύρου
const float WINDOW_WIDTH = 800.0f;
const float WINDOW_HEIGHT = 600.0f;
// Δημιουργία του παίκτη
Player player = {
	400.0f, 300.0f, // Αρχική θέση
	50.0f, 30.0f, // Διαστάσεις του παίκτη
	5.0f, // Ταχύτητα του παίκτη
	0.0f, // Αρχικός προσανατολισμός
	false,
	false,
	1.0f,
	0.5f,
	{ {1.0f, 0.0f, 0.0f} }, // Κόκκινη μπροστινή πλευρά
	{ {0.6f, 0.0f, 0.0f} } // Σκουρότερη κόκκινη πίσω πλευρά
};
/**
* Συνάρτηση σχεδίασης που καλείται σε κάθε καρέ.
*/
void draw() {
	// Καθαρισμός παραθύρου
	graphics::Brush bgBrush;
	bgBrush.fill_color[0] = 1.0f;
	bgBrush.fill_color[1] = 1.0f;
	bgBrush.fill_color[2] = 1.0f;
	graphics::drawRect(WINDOW_WIDTH / 2, WINDOW_HEIGHT / 2, WINDOW_WIDTH,
		WINDOW_HEIGHT, bgBrush);
	// Σχεδίαση του παίκτη
	drawPlayer(player);
}
/**
* Συνάρτηση ενημέρωσης που καλείται περιοδικά.
* @param ms Τα χιλιοστά του δευτερολέπτου από την τελευταία κλήση της συνάρτησης.
*/
void update(float ms) {
	slowKeyboardInput(50);
	// Movement controls
	if (graphics::getKeyState(graphics::SCANCODE_UP)) {
		moveForward(player);
		enforceBounds(player, WINDOW_WIDTH, WINDOW_HEIGHT); // Διασφάλιση ορίων
	}
	if (graphics::getKeyState(graphics::SCANCODE_DOWN)) {
		moveBackward(player);
		enforceBounds(player, WINDOW_WIDTH, WINDOW_HEIGHT); // Διασφάλιση ορίων
	}
	if (graphics::getKeyState(graphics::SCANCODE_LEFT)) {
		rotateLeft(player, 5.0f);
	}
	if (graphics::getKeyState(graphics::SCANCODE_RIGHT)) {
		rotateRight(player, 5.0f);
	}
	// Action controls
	if (graphics::getKeyState(graphics::SCANCODE_1)) {
		jumpY(player, 30.0f); // Simulate jump
		enforceBounds(player, WINDOW_WIDTH, WINDOW_HEIGHT);
	}
	if (graphics::getKeyState(graphics::SCANCODE_0)) {
		jumpX(player, 30.0f); // Simulate jump
		enforceBounds(player, WINDOW_WIDTH, WINDOW_HEIGHT);
	}
	if (graphics::getKeyState(graphics::SCANCODE_R)) {
		sprint(player, 2.0f); // Sprint with speed multiplier
		enforceBounds(player, WINDOW_WIDTH, WINDOW_HEIGHT);
	}
	if (graphics::getKeyState(graphics::SCANCODE_W)) {
		walk(player, 0.5f); // Walk with speed reduction
		enforceBounds(player, WINDOW_WIDTH, WINDOW_HEIGHT);
	}
}
int main() {
	// Δημιουργία παραθύρου
	graphics::createWindow(WINDOW_WIDTH, WINDOW_HEIGHT, "Player Movement");
	// Αρχικοποίηση και ορισμός της συνάρτησης σχεδίασης
	graphics::setDrawFunction(draw);
	// Ορισμός της συνάρτησης ενημέρωσης
	graphics::setUpdateFunction(update);
	// Έναρξη του κύκλου μηνυμάτων
	graphics::startMessageLoop();
	return 0;
}